/* "eqcs_qc_rep.h"
 * Copyright (C) 1999 Peter Belkner <pbelkner@berlin.snafu.de>
 *
 * This file is part of the eqcs library. This library is free
 * software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; see the file COPYING.  If not, write to the
 * Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */
#ifndef	_EQCS_QC_REP_H_
#ifdef __GNUG__
#pragma interface
#endif
#define	_EQCS_QC_REP_H_

#include "eqcs_body.h"
#include "eqcs_state.h"

class EqcsGate;
class EqcsGateArray;

/*****************************************************************************\
*	quantum computer representation											  *
\*****************************************************************************/

class EqcsQcRep: public EqcsBody {
public:
	EqcsQcRep(const EqcsState &state);
	virtual ~EqcsQcRep();

	// Prepare the quantum computer in some state.
	void prepare(const EqcsState &state);
	// Observe some bits.
	EqcsState observe(unsigned long bits);
	// Perform one instruction.
	void perform(const EqcsGate &gate);
	// Perform a sequence of instructions.
	void perform(const EqcsGateArray &array);

    EqcsBitset measure(unsigned long bits) const;

	EqcsState state() const
		{ return _state; }
private:
	EqcsState		_state;
};

#endif	//	_EQCS_QC_REP_H_
